/*
 * ctcp.c: client to client protocol
 *
 * Copyright(c) 1997,1998 - All Rights Reserved
 *
 * See the COPYRIGHT file.
 */

#ifndef lint
static char rcsid[] = "@(#)$Id: ctcp.c,v 1.6 1998/03/03 23:07:02 kalt Exp $";
#endif

#include "os.h"

#include "server.h"
#include "patchlevel.h"

extern	int	cmd_msgnotice(char *, char *);

int
cmd_ctcp(p)
  char *p;
{
  char *wp, *wp2, wbuf[512];

  wp = index(p, ' ');
  if (!wp)
      return -1;
  *wp++ = '\0';
  wp2 = wp;
  while (*wp2 && *wp2 != ' ')
    {
      *wp2 = toupper(*wp2);
      wp2++;
    }
  sprintf(wbuf, "%s \001%s\001", p, wp);
  cmd_msgnotice("PRIVMSG", wbuf);
  return 0;
}

int
cmd_ping(p)
  char *p;
{
  char buf[512];

  if (!*p)
      return -1;
  if (index(p, ' '))
      return -4;
  sprintf(buf, "%s PING %lu", p, time(NULL));
  return cmd_ctcp(buf);
}

/*
 * basic flood protection stuff.
 * I've always said it's easy, and it is, but this is a simple method
 * which I don't like much.  I'll improve when I get a chance.
 */
static	time_t	last_t = 0;
static	char	last_cnt;

void
sic_ctcp(nick, toself, txt)
  char *nick, *txt;
  char toself;
{
  char *b, *e, *s;
  int cnt = 0;
  char reply[512] = "", temp[512];

  if ((time(NULL) - last_t) < 10)
    {
      if (++last_cnt >= 3)
	  return;
    }
  else
    {
      last_t = time(NULL);
      last_cnt = 1;
    }

  sprintf(reply, "%s ", nick);
  while (b = index(txt, '\001'))
    {
      if ((e = index(++b, '\001')) == NULL)
	  break;
      if ((s = index(b, ' ')) == NULL)
	  s = e;
      
      *s = '\0';
      temp[0] = '\0';

      if (!strcmp("CLIENTINFO", b))
	  strcpy(temp, "\001CLIENTINFO CLIENTINFO PING TIME VERSION\001");
      else if (!strcmp("PING", b))
	  sprintf(temp, "\001PING %s", (s != e) ? s+1 : "");
      else if (!strcmp("TIME", b))
	{
	  char btime[80];
	  time_t t;
	  
	  t = time(NULL);
	  sprintf(btime, "\001TIME %s", ctime(&t));
	  btime[strlen(btime) - 1] = '\0';
	  sprintf(temp, "%s\001", btime);
	}
      else if (!strcmp("VERSION", b))
	  sprintf(temp, "\001VERSION sic %s\001", version);

      if (s)
	  if (s == e)
	      *s = '\001';
	  else
	      *s = ' ';

      if (strlen(temp) + strlen(reply) > 256)
	  break;
      strcat(reply, temp);

      if (cnt++ > 4)
	  break;
      txt = e+1;
    }
  if (cnt > 0 && cnt <= 5)
      cmd_msgnotice("NOTICE", reply);
  else
    {
    }
}
